#!/usr/local/bin/perl
$UsePipe=1;
$SpoolDir="";
$TempDir="";
#$SpoolDir="AutoDec/";
#$TempDir="/tmp/";
#------------------------------------------------
$Part=0;
$Total=0;
$Fname="";
$Logfile= sprintf( "%sautodec.log", $Logfile );
$MsgSwitch= 0;
$DecodeMode= 0;
$ShArcDec= 1;
#------------------------------------------------
sub spoolname
{
	return	sprintf( "%s%s.%04d", $SpoolDir, $_[0], $_[1] );
}
#------------------------------------------------
sub msg
{
	if( $MsgSwitch ){
		print( $_[0] );
	}
}
sub dmsg
{
	if( $MsgSwitch == 2 ){
		print( $_[0] );
	}
}
#------------------------------------------------
sub partnumber
{
	local( $line )= @_;
	if( $line =~/part/i ){
		if( $line =~m=(\S+) +part *(\d+) *(/|of) *(\d+)=i ){
&dmsg( sprintf("line=%s\n", $line ) );
&dmsg( sprintf("line part %d/%d\n", $2, $4 ) );
			$Fname=$1;
			$Part=$2;
			$Total=$4;
			return	0;
		}
	}
	return	1;
}
#------------------------------------------------
sub totalcheck
{
	local( $name, $total )= @_;
	local( $i, $count );
	for( $i= 1, $count= 0 ; $i <= $total ; $i++ ){
		unless( -e sprintf( "%s%s.%04d", $SpoolDir, $name, $i ) ){
			$count++;
		}
	}
	return	$count;
}
#------------------------------------------------
sub decode
{
	local( $name, $total )= @_;
	local( $i, $cmd, $tname );
if( $UsePipe ){
	$cmd="aish";
	if( open( POUT, "|$cmd -" ) ){
		for( $i= 1 ; $i <= $total ; $i++ ){
			&msg( "  decode - $i/$total\n" );
			$tname= sprintf( "%s%s.%04d", $SpoolDir, $name, $i );
			if( open( IFILE, $tname ) ){
				while(<IFILE>){
					print POUT;
				}
				close( IFILE );
				unlink( $tname );
			}else{
				warn( "$tname:file open error\n" );
			}
		}
		close( POUT );
		&msg( "[$name] decode end\n" );
	}else{
		warn( "$cmd:command error\n" );
	}
}else{
	$cmd= sprintf( "%s%s.all", $TempDir, $name );
	if( open( POUT, ">$cmd" ) ){
		for( $i= 1 ; $i <= $total ; $i++ ){
			&msg( "  decode - $i/$total\n" );
			$tname= sprintf( "%s%s.%04d", $SpoolDir, $name, $i );
			if( open( IFILE, $tname ) ){
				while(<IFILE>){
					print POUT;
				}
				close( IFILE );
				unlink( $tname );
			}else{
				warn( "$tname:file open error\n" );
			}
		}
		close( POUT );
		system( "aish $cmd" );
		unlink( $cmd );
		&msg( "[$name] decode end\n" );
	}else{
		warn( "output $cmd error\n" );
	}
}
}
#------------------------------------------------
sub decname
{
	local( $pline, $nline )= @_;
	local( $oname );
	if( &partnumber( $pline ) ){
		if( &partnumber( $nline ) ){
			$Part= $PPart;
			$Total= $PTotal;
		}
	}
	if( $Part == 0 || $PTotal == 0 || $Part > $PTotal ){
		if( $DecodeMode == 1 ){
			return	"";
		}
		$Part= 1;
		$Total= 1;
		$Fname= "unknown_1";
	}
	if( $Fname eq "" ){
		$Fname= "unknown";
	}
	$oname= &spoolname( $Fname, $Part );
	&msg( "$Fname - $Part/$Total -> $oname\n" );
	return	$oname;
}
#------------------------------------------------
sub logflush
{
	local( $shellarc )= @_;
	$oname= &decname( "", "" );
	close( LOGFILE );
	if( $oname eq "" ){
		unlink( $Logfile );
	}else{
		if( $shellarc ){
			$td= sprintf( "%ssh_arc.tmp", $Tempdir );
			system( "sed '1,/^#!/d' $Logfile > $td" );
			system( "sh $td" );
			unlink( $td );
			unlink( $Logfile );
		}else{
			rename( $Logfile, $oname );
			$count= &totalcheck( $Fname, $Total );
			if( $count == 0 ){
				&decode( $Fname, $Total );
			}else{
				&msg( " -- $count\n" );
			}
		}
	}
	$PPart= 0;
	$PTotal= 0;
	$Fname="";
}
#------------------------------------------------
sub logopen
{
	unless( open( LOGFILE, ">$Logfile" ) ){
		warn( "$Logfile write error.\n" );
	}
}
#------------------------------------------------
sub mainloop
{
	local( $INFILE )= @_;
	local( $count, $pline, $nline, $oname, $logopen, $shellarc );
	$logopen= 0;
	$shellarc= 0;
	while(<$INFILE>){
		$nline= $_;
		if( /^Subject: / ){
			if( $logopen ){
				&logflush( $shellarc );
				$logopen= 0;
			}
			$_= $nline;
#if( m=(\d+) *(/|of) *(\d+) *\)=i )
			if( m=(\d+) *(/|of) *(\d+) *=i ){
&dmsg( sprintf( "subject=%s\n", $_ ) );
&dmsg( sprintf("subject part %d/%d\n", $1, $3 ) );
				$PPart= $1;
				$PTotal= $3;
				s/\W*//g;
				$Fname= substr( $_, 8, 12 );
			}
			&logopen;
			$logopen= 1;
			$shellarc= 0;
		}elsif( /^Part-Number/ ){
			if( m=(\d+) *(/|of) *(\d+) *=i ){
&dmsg( sprintf( "header=%s\n", $_ ) );
&dmsg( sprintf("header part %d/%d\n", $1, $3 ) );
				$PPart= $1;
				$PTotal= $3;
			}
		}elsif( m=#! ?/bin/sh= ){
			if( $ShArcDec ){
				$shellarc= 1;
				if( $ShArcDec == 1 ){
					$nline= <$INFILE>;
					if( $nline =~ /^#.+shell archive.+shar/ ){
						$shellarc++;
					}
				}
			}
		}elsif( /^BEGIN/ ){
			if( $logopen ){
				close( LOGFILE );
				unlink( $Logfile );
				$logopen= 0;
			}
			$shellarc= 0;
			$oname= &decname( $pline, $_ );
			if( open( OFILE, ">$oname" ) ){
				while(<$INFILE>){
					if( /^END/ ){
						last;
					}
					print OFILE;
				}
				close( OFILE );
				$count= &totalcheck( $Fname, $Total );
				if( $count == 0 ){
					&decode( $Fname, $Total );
				}else{
					&msg( " -- $count\n" );
				}
			}else{
				warn( "$oname write error.\n" );
				last;
			}
			$PPart= 0;
			$PTotal= 0;
			$Fname="";
		}
		$pline=$nline;
		if( $logopen ){
			print LOGFILE;
		}
	}
	if( $logopen ){
		&logflush( $shellarc );
	}
}
#------------------------------------------------
sub usage
{
	print	"usage: autodecode [-v] [-i] [-p] [file..]\n";
}
#------------------------------------------------
#main
#{
	for( $i= 0 ; $i<=$#ARGV ; $i++ ){
		$_= $ARGV[$i];
		if( /^-v/ ){
			$MsgSwitch= 1;
			splice( @ARGV, $i--, 1 );
		}elsif( /^-VV/ ){
			$MsgSwitch= 2;
			splice( @ARGV, $i--, 1 );
		}elsif( /^-p/ ){
			$UsePipe= 0;
			splice( @ARGV, $i--, 1 );
		}elsif( /^-i/ ){
			$DecodeMode= 1;
			splice( @ARGV, $i--, 1 );
		}elsif( /^-s/ ){
			$ShArcDec= 0;
			splice( @ARGV, $i--, 1 );
		}elsif( /^-S/ ){
			$ShArcDec= 2;
			splice( @ARGV, $i--, 1 );
		}elsif( /^-/ ){
			&usage;
			exit 1;
		}
	}
	if( $#ARGV < 0 ){
		&mainloop( STDIN );
	}else{
		foreach $fname ( @ARGV ){
			&msg( ">>> $fname <<<\n" );
			unless( open( IMFILE, $fname ) ){
				warn( "Can't open $fname.\n" );
				next;
			}
			&mainloop( IMFILE );
			close( IMFILE );
		}
	}
#}
#------------------------------------------------
# Copyright 1994,95 Ogasawara Hiroyuki (COR.)
# oga@dgw.yz.yamagata-u.ac.jp
